org.glassfish.jersey.server.monitoring

## Interface ExecutionStatistics

    public interface ExecutionStatistics

Monitoring statistics of execution of one target. `ExecutionStatistics` contains `TimeWindowStatistics` for various time window sizes.

Statistics retrieved from Jersey runtime might be mutable and thanks to it might provide inconsistent data as not all statistics are updated in the same time. To retrieve the immutable and consistent statistics data the method `snapshot()` should be used.

Author:
  Miroslav Fuksa
See Also:
  `See monitoring statistics for general details about statistics.`

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`Date` `getLastStartTime()` Return time when target was executed last time.
`Map<Long,TimeWindowStatistics>` `getTimeWindowStatistics()` Returns time window statistics for available time window sizes.
`ExecutionStatistics` `snapshot()` Deprecated. implementing class is immutable hence snapshot creation is not needed anymore

### Method Detail

#### getLastStartTime

    Date getLastStartTime()

Return time when target was executed last time. The time is measured before the target was executed.

Returns:
  Time of last execution.

#### getTimeWindowStatistics

    Map<Long,TimeWindowStatistics> getTimeWindowStatistics()

Returns time window statistics for available time window sizes. The returned map contains sizes of a time window in milliseconds as keys and `time window statistics` for the corresponding time window as value.

Returns:
  Map with size of a time window in milliseconds as keys and `time window statistics` for the corresponding time window as value.

#### snapshot

    @Deprecated
    ExecutionStatistics snapshot()

Deprecated. implementing class is immutable hence snapshot creation is not needed anymore
Get the immutable consistent snapshot of the monitoring statistics. Working with snapshots might have negative performance impact as snapshot must be created but ensures consistency of data over time. However, the usage of snapshot is encouraged to avoid working with inconsistent data. Not all statistics must be updated in the same time on mutable version of statistics.

Returns:
  Snapshot of execution statistics.